#include "stdafx.h"
#include "dvi2pdfset.h"
#include "Setting.h"
#include "resource.h"

extern Setting g_setting;

const TCHAR *DVI2PDFSet::m_papersize[] = {
	_T("a6"),_T("a5"),_T("a4"),_T("a3"),_T("b6"),_T("b5"),_T("b4"),_T("b3"),_T("b5ver"),NULL
};

bool DVI2PDFSet::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::Combo plist(wnd,IDC_PAPERLIST);
	for(const TCHAR **p = m_papersize ; *p ; ++p)plist.AddString(*p);
	int len = plist.GetCount();
	ablib::string psize = g_setting.DVI2PDF_PaperSizeFromList();
	for(int i = 0 ; i < len ; ++i)if(psize == plist.GetText(i))plist.SetCurSel(i);

	switch(g_setting.DVI2PDF_WhichProgram()){
	case dvipdfmx:
		ablib::window::CheckBox(wnd,IDC_DVIPDFMX).SetCheck(true);
		break;

	case other:
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).SetCheck(true);
		break;

	}
	ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());

	ablib::window::CheckBox(wnd,IDC_PAPERSIZE_GUESS).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
	ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NOUSE).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());

	switch(g_setting.DVI2PDF_WhichPaperSize()){
	case guess:
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_GUESS).SetCheck(true);
		break;

	case list:
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).SetCheck(true);
		break;

	case number:
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).SetCheck(true);
		break;

	default:
	case nouse:
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NOUSE).SetCheck(true);
		break;
	}

	ablib::window::Combo(wnd,IDC_PAPERLIST).Enabled(
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).GetCheck() &&
		!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
		);
	ablib::window::Edit(wnd,IDC_HEIGHT).SetReadOnly(
		!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
		);
	ablib::window::Edit(wnd,IDC_WIDTH).SetReadOnly(
		!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
		);

	ablib::window::Edit(wnd,IDC_PROGRAM).SetText(g_setting.DVI2PDF_Program());
	ablib::window::Edit(wnd,IDC_OPTION).SetText(g_setting.DVI2PDF_Option());
	ablib::window::Edit(wnd,IDC_HEIGHT).SetText(g_setting.DVI2PDF_PaperSizeX());
	ablib::window::Edit(wnd,IDC_WIDTH).SetText(g_setting.DVI2PDF_PaperSizeY());
	return true;
}

bool DVI2PDFSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_DVIPDFMX:
	case IDC_OTHERPROGRAM:
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		ablib::window::Combo(wnd,IDC_PAPERLIST).Enabled(
			ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).GetCheck() &&
			!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);
		ablib::window::Edit(wnd,IDC_HEIGHT).SetReadOnly(
			!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
			ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);
		ablib::window::Edit(wnd,IDC_WIDTH).SetReadOnly(
			!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
			ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);

		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_GUESS).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NOUSE).Enabled(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());

		return true;

	case IDC_PAPERSIZE_GUESS:
	case IDC_PAPERSIZE_LIST:
	case IDC_PAPERSIZE_NUMBER:
	case IDC_PAPERSIZE_NOUSE:
		ablib::window::Combo(wnd,IDC_PAPERLIST).Enabled(
			ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).GetCheck() &&
			!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);
		ablib::window::Edit(wnd,IDC_HEIGHT).SetReadOnly(
			!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
			ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);
		ablib::window::Edit(wnd,IDC_WIDTH).SetReadOnly(
			!ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck() ||
			ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()
			);
		return true;

	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_DVIPDFMX).GetCheck())g_setting.WriteDVI2PDF_WhichProgram(dvipdfmx);
		else g_setting.WriteDVI2PDF_WhichProgram(other);

		if(ablib::window::CheckBox(wnd,IDC_PAPERSIZE_GUESS).GetCheck())g_setting.WriteDVI2PDF_WhichPaperSize(guess);
		else if(ablib::window::CheckBox(wnd,IDC_PAPERSIZE_LIST).GetCheck())g_setting.WriteDVI2PDF_WhichPaperSize(list);
		else if(ablib::window::CheckBox(wnd,IDC_PAPERSIZE_NUMBER).GetCheck())g_setting.WriteDVI2PDF_WhichPaperSize(number);
		else g_setting.WriteDVI2PDF_WhichPaperSize(nouse);

		g_setting.WriteDVI2PDF_Program(ablib::window::Edit(wnd,IDC_PROGRAM).GetText());
		g_setting.WriteDVI2PDF_Option(ablib::window::Edit(wnd,IDC_OPTION).GetText());
		g_setting.WriteDVI2PDF_PaperSizeFromList(ablib::window::Combo(wnd,IDC_PAPERLIST).GetText());
		g_setting.WriteDVI2PDF_PaperSizeX(ablib::window::Edit(wnd,IDC_HEIGHT).GetText());
		g_setting.WriteDVI2PDF_PaperSizeY(ablib::window::Edit(wnd,IDC_WIDTH).GetText());

		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}



