#include "stdafx.h"
#include "window/Dialog.h"
#include "mainwnd.h"
#include "TeX2DVISet.h"
#include "DVI2PSSet.h"
#include "DVI2PDFSet.h"
#include "PS2PDFSet.h"
#include "DVIOUTSet.h"
#include "PreviewSet.h"
#include "TeXSet.h"
#include "id.h"
#include "OneTextDlg.h"
#include "ablib/CmdLine.h"
#include "ablib/IsKanji.h"

extern HINSTANCE g_appint;

MainWnd::MainWnd(HINSTANCE appint): 
BaseWnd(_T("ABENORI_TEXSHELL"),WS_OVERLAPPEDWINDOW,appint,true),
m_edit(appint,&m_process),m_bardlg(appint),m_tex(&m_edit),
m_history(5)
{
	m_tex.SetMainWnd(this);
	if(!m_edit.readonly())m_edit.readonlyswitch();
}

bool MainWnd::CmdLine(const ablib::CmdLine &cmd){
	for(int i = 0 ; i < cmd.GetArgc() ; ++i){
		m_tex.SetFile(cmd.GetArgv(i),m_history);
		SetMenu();
		GetWindow()->SetTitle(_T("TeXShell2 ") + m_tex.GetFile());
		m_tex.GetDocumentInfo();
		m_tex.DO(m_tex.GetToDO());
	}
	return false;
}

bool MainWnd::OnCreate(ablib::window::Window *wnd){
	wnd->SetTitle(_T("TeXShell2"));
	ablib::window::Rect rc = wnd->GetRect();
	if(!m_edit.Create(wnd))return false;
//	if(!m_bardlg.Create(wnd))return false;

	std::vector<ablib::window::ToolBar::SysButton> systool;
	systool.push_back(ablib::window::ToolBar::SysButton(STD_FILEOPEN,IDM_FILE_OPEN));

	if(!ablib::window::ToolBar::CreateSysToolBar(wnd,IDR_TOOLBAR,systool,ablib::window::Point(0,0)))return false;
	ablib::window::ToolBar tool(wnd,IDR_TOOLBAR);

	std::vector<WORD> mytool;
	mytool.push_back(IDM_FILE_DVIPREVIEW);
	mytool.push_back(IDM_FILE_PSPREVIEW);
	mytool.push_back(IDM_FILE_PDFPREVIEW);
	mytool.push_back(IDM_FILE_TEX2DVI);
	mytool.push_back(IDM_FILE_DVI2PS);
	mytool.push_back(IDM_FILE_DVI2PDF);
	mytool.push_back(IDM_FILE_PS2PDF);
	tool.Add(mytool,IDR_TOOLBAR,g_appint);

	tool.InsertSep(1);
	tool.InsertSep(5);

	std::vector<ablib::window::ToolBar::ToolTip> tips;
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_OPEN,IDS_FILEOPEN));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_DVIPREVIEW,IDS_DVIPREVIEW));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_PSPREVIEW,IDS_PSPREVIEW));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_PDFPREVIEW,IDS_PDFPREVIEW));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_TEX2DVI,IDS_TEX2DVI));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_DVI2PS,IDS_DVI2PS));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_DVI2PDF,IDS_DVI2PDF));
	tips.push_back(ablib::window::ToolBar::ToolTip(IDM_FILE_PS2PDF,IDS_PS2PDF));

	tool.SetToolTip(tips,g_appint);


	SetMenu();
	wnd->EnableDandD(true);
	return true;
}

bool MainWnd::OnDropFiles(const std::vector<ablib::string> &files){
	for(std::vector<ablib::string>::size_type i = 0 ; i < files.size() ; ++i){
		m_tex.SetFile(files[i],m_history);
		SetMenu();
		GetWindow()->SetTitle(_T("TeXShell2  ") + m_tex.GetFile());
		m_edit.RemoveAllText();
		m_tex.GetDocumentInfo();
		m_tex.DO(m_tex.GetToDO());
	}
	return true;
}

bool MainWnd::OnSize(ablib::window::Window *wnd,int sw,int width,int height){
	ablib::window::ToolBar tool(wnd,IDR_TOOLBAR);
	tool.AutoSize();
	ablib::window::Rect rc = wnd->GetClientRect();
//	ablib::window::Rect barrc = m_bardlg.GetWindow()->GetClientRect();
	ablib::window::Rect barrc;barrc.top = barrc.bottom = barrc.left = barrc.right = 0;
	ablib::window::Rect toolrc = tool.GetClientRect();
	m_edit.GetWindow()->Move(ablib::window::Point(0,barrc.bottom - barrc.top + toolrc.bottom - toolrc.top + 2),
		ablib::window::Size(rc.right - rc.left,rc.bottom - rc.top - (barrc.bottom - barrc.top) - (toolrc.bottom - toolrc.top) - 2));
//	m_bardlg.GetWindow()->Move(ablib::window::Point(0,toolrc.bottom),
//		ablib::window::Point(rc.right - rc.left,barrc.bottom - barrc.top));
	return true;
}

bool MainWnd::OnSetFocus(ablib::window::Window *wnd,ablib::window::Window *old){
	m_edit.GetWindow()->SetFocus();
	return true;
}

bool MainWnd::OnCommand(ablib::window::Window *wnd,int id,int param){
	if(!m_process.HasExited())return true;
	switch(id){
	case IDM_FILE_OPEN:
	{
		ablib::string rv;
		if(ablib::window::CommonDlg(wnd).OpenFileDlg(rv,
			_T("TeX֘At@C\0*.tex;*.dvi;*.ps;*.pdf\0SẴt@C\0*.*"),
			_T("t@CJ"),_T(""))){

			m_tex.SetFile(rv,m_history);
			SetMenu();
			wnd->SetTitle(_T("TeXShell2  ") + m_tex.GetFile());
			m_edit.RemoveAllText();
			m_tex.GetDocumentInfo();
			m_tex.DO(m_tex.GetToDO());
		}
		return true;
	}
	case IDM_FILE_TEX2DVI:
		m_edit.RemoveAllText();
		m_tex.GetDocumentInfo();
		m_tex.TeX2DVI();
		return true;
	case IDM_FILE_DVI2PDF:
		m_edit.RemoveAllText();
		m_tex.GetDocumentInfo();
		m_tex.DVI2PDF();
		return true;
	case IDM_FILE_DVI2PS:
		m_edit.RemoveAllText();
		m_tex.GetDocumentInfo();
		m_tex.DVI2PS();
		return true;
	case IDM_FILE_PS2PDF:
		m_edit.RemoveAllText();
		m_tex.GetDocumentInfo();
		m_tex.PS2PDF();
		return true;
	case IDM_FILE_DVIPREVIEW:
		m_tex.GetDocumentInfo();
		m_tex.DVIPreview();
		return true;
	case IDM_FILE_PSPREVIEW:
		m_tex.GetDocumentInfo();
		m_tex.PSPreview();
		return true;
	case IDM_FILE_PDFPREVIEW:
		m_tex.GetDocumentInfo();
		m_tex.PDFPreview();
		return true;
	case IDM_FILE_EXECCMD:
	{
		m_tex.GetDocumentInfo();
		OneTextDlg otd(g_appint);
		ablib::string cmd;
		if(!otd.Create(wnd,_T("R}hs"),_T("sR}h͂ĂD"),cmd))return true;
		cmd = m_tex.TransStr(cmd);
		ablib::string dir = m_tex.GetDir();
		if(dir == _T("")){
			TCHAR buf[4096];
			::GetModuleFileName(NULL,buf,4095);
			dir = buf;
			dir.erase(dir.rfind(_T("\\")));
		}
		Exec(cmd,dir);
		return true;
	}
	case IDM_FILE_QUIT:
		wnd->Destroy();
		return true;

	case IDM_OTHER_VERSION:
	{
		Version ver(g_appint);
		ver.Create(wnd);
		return true;
	}

	case IDM_SET_TEX2DVI:
	{
		TeX2DVISet ps(g_appint);
		ps.Create(wnd);
		return true;
	}
	case IDM_SET_DVI2PS:
	{
		DVI2PSSet dvi2ps(g_appint);
		dvi2ps.Create(wnd);
		return true;
	}
	case IDM_SET_DVI2PDF:
	{
		DVI2PDFSet dvi2pdf(g_appint);
		dvi2pdf.Create(wnd);
		return true;
	}
	case IDM_SET_PS2PDF:
	{
		PS2PDFSet ps2pdf(g_appint);
		ps2pdf.Create(wnd);
		return true;
	}
	case IDM_SET_DVIPREVIEW:
	{
		DVIOUTSet dviout(g_appint);
		dviout.Create(wnd);
		return true;
	}
	case IDM_SET_OTHERPREVIEW:
	{
		PreviewSet preview(g_appint);
		preview.Create(wnd);
		return true;
	}
	case IDM_SET_TEX:
	{
		TeXSet ts(g_appint);
		ts.Create(wnd);
		return true;
	}

	default:
		if(IDM_HISTORY_BASE <= id && id <= IDM_HISTORY_BASE + 20){
			m_tex.SetFile(m_history.Get(id - IDM_HISTORY_BASE),m_history);
			SetMenu();
			wnd->SetTitle(_T("TeXShell2  ") + m_tex.GetFile());
			m_edit.RemoveAllText();
			m_tex.GetDocumentInfo();
			m_tex.DO(m_tex.GetToDO());
			return true;
		}
		return false;
	}
}

void MainWnd::SetMenu(){
	GetWindow()->GetMenu()->Clear();
	GetWindow()->GetMenu()->AddRootMenu(IDM_FILE,_T("t@C(&F)"));
	GetWindow()->GetMenu()->AddRootMenu(IDM_SET,_T("ݒ(&S)"));
	GetWindow()->GetMenu()->AddRootMenu(IDM_OTHER,_T("̑(&O)"));

	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_OPEN,_T("J(&O)"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,0);
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_TEX2DVI,_T("TeXDVI"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_DVI2PS,_T("DVIPS"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_DVI2PDF,_T("DVIPDF"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_PS2PDF,_T("PSPDF"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,0);
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_DVIPREVIEW,_T("DVIt@C̃vr["));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_PSPREVIEW,_T("PSt@C̃vr["));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_PDFPREVIEW,_T("PDFt@C̃vr["));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,0);
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_EXECCMD,_T("R}h̎s"));
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,0);
	int i;
	for(i = 0 ; i < 20 ; ++i){
		ablib::string hist = m_history.Get(i);
		if(hist != _T(""))GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_HISTORY_BASE + i,hist.c_str());
		else break;
	}
	if(i != 0)GetWindow()->GetMenu()->AddMenu(IDM_FILE,0);
	GetWindow()->GetMenu()->AddMenu(IDM_FILE,IDM_FILE_QUIT,_T("I"));

	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_TEX2DVI,_T("TeXDVI"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_DVI2PS,_T("DVIPS"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_DVI2PDF,_T("DVIPDF"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_PS2PDF,_T("PSPDF"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,0);
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_DVIPREVIEW,_T("DVI{\tg"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_OTHERPREVIEW,_T("̑̉{\tg"));
	GetWindow()->GetMenu()->AddMenu(IDM_SET,IDM_SET_TEX,_T("SʓIȐݒ"));

	GetWindow()->GetMenu()->AddMenu(IDM_OTHER,IDM_OTHER_HELP,_T("wv"));
	GetWindow()->GetMenu()->AddMenu(IDM_OTHER,IDM_OTHER_VERSION,_T("o[W"));

	GetWindow()->GetMenu()->CreateWindowMenu();
	return;
}

bool MainWnd::Exec(const ablib::string &cmd,const ablib::string &dir){
	if(!m_process.HasExited())return false;
	ablib::system::Process::ProcessStartInfo si;
	si.Arguments = cmd;
	si.WorkingDirectory = dir;
	si.RedirectStandardInput = si.RedirectStandardOutput = si.RedirectStandardError = true;
	si.CreateNoWindow = true; si.ShowState = ablib::system::Process::ProcessStartInfo::showstate::hide;
	m_process.StartInfo(si);

	if(!m_process.Start())return false;

	m_edit.insert(_T("///////////////////////////////////////////\n"));
	m_edit.insert(_T("JgfBNg : ") + dir + _T("\n"));
	m_edit.insert(_T("R}h : ") + cmd + _T("\n"));
	m_edit.insert(_T("///////////////////////////////////////////\n"));
	
	bool end = false;
	MSG msg;
	TCHAR buf[4096];
	int bufidx = 0;
	ablib::string ins;
	ins.reserve(4096);
	do{
		switch(m_process.WaitForMsg(20)){
		case ablib::system::Process::process_exit:
			end = true;
			break;
		case ablib::system::Process::message:
			while(::PeekMessage(&msg,0,0,0,PM_REMOVE)){
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			break;
		default:
			break;
		}
		if(m_process.HasExited())end = true;
		while(DWORD readsize = m_process.Read(buf + bufidx,4094)){
			readsize += bufidx;
			buf[readsize] = '\0';
			//ȉsR[hDsakura editorQlɂĂ܂D
			//\r\n,\r\nɕϊD
			ins = _T("");
			int i;
			for(i = 0 ; i < static_cast<int>(readsize) - 1 ; i++){
				if(ablib::IsKanji(buf[i])){
					ins += buf[i];
					i++;
					ins += buf[i];
				}else if(buf[i] == '\r'){
					if(buf[i + 1] == '\n')i++;
					ins += _T("\n");
				}else ins +=  buf[i];
			}
			if(i == readsize - 1){
				if(ablib::IsKanji(buf[i]))i = readsize + 1;
				else if(buf[i] == '\r')i = readsize + 1;
				else{ins += buf[i];i = readsize;}
			}
			if(i == readsize)bufidx = 0;
			else{
				buf[0] = buf[readsize - 1];
				bufidx = 1;
			}
			m_edit.gofileend();
			m_edit.insert(ins);
		}
	}while(!end);
	m_edit.insert(_T("\n\n"));
	return true;
}


bool MainWnd::Edit::OnChar(ablib::window::Window *wnd,TCHAR ch,int repeat){
	if(m_process->HasExited())return false;
	ablib::string::size_type n = m_keybuf.length();
	if(::GetKeyState(VK_CONTROL) < 0)return false;
	if(ch == 0x08){//BackSpace
		if(n != 0){
			m_keybuf.erase(n - 1);
			gofileend();
			backspace();
		}
	}else if(ch == '\r'){//Return
		m_keybuf += _T("\n");
		m_process->Write(m_keybuf.c_str(),m_keybuf.length());
		insert(_T("\n"));
		gofileend();
		m_keybuf = _T("");
		return true;
	}else if(ch == 27 || ch == 9 || ch == 28 || ch == 29 || ch == 30 ||ch == 31)return false;//Esc,Tab,,,,
	else if(ch < 127){
		m_keybuf += ch;
		gofileend();
		insert(ch);
		return true;
	}
	return false;
}

bool MainWnd::Edit::OnRButtonDown(ablib::window::Window *wnd,ablib::window::Mouse *mos,bool isDClick){
	if(isDClick)return false;
	ablib::window::Menu m(wnd);
	m.AddRootMenu(IDM_EDIT_SELECTALL,_T("SđI"));
	m.AddRootMenu(IDM_EDIT_COPY,_T("Rs["));
	switch(m.CreatePopupMenu(mos->GetPos())){
	case IDM_EDIT_SELECTALL:
		selectall();
		break;
	case IDM_EDIT_COPY:
		copy();
		break;
	default:
		break;
	}
	return true;
}

